/*
 File: parallel_monitor_phsym.cpp
 Date and Time: Fri Jan 30 18:55:18 2015 
*/
#include "parallel_monitor_ph.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_parallel_monitor_ph;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_parallel_monitor_ph::TH_parallel_monitor_ph(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_parallel_monitor_ph;
  NS_parallel_monitor_ph::Cparallel_monitor_ph Cparallel_monitor_ph_;// parallel-parser's parse table
#define ssPARSE_TABLE Cparallel_monitor_ph_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_parallel_monitor_ph::PROC_TH_parallel_monitor_ph(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_parallel_monitor_ph";
  static bool one_time(false);
  static NS_parallel_monitor_ph::Cparallel_monitor_ph* NS_parallel_monitor_ph_Cparallel_monitor_ph_(0);// parallel-parser's fsm table
  static Parser* NS_parallel_monitor_ph_Cparallel_monitor_ph_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_parallel_monitor_ph_Cparallel_monitor_ph_ = new NS_parallel_monitor_ph::Cparallel_monitor_ph();// parallel-parser's fsm table
    NS_parallel_monitor_ph_Cparallel_monitor_ph_parser = new Parser(*NS_parallel_monitor_ph_Cparallel_monitor_ph_,Caller_pp);
  }
 proc_parser = NS_parallel_monitor_ph_Cparallel_monitor_ph_parser;
#include "wproc_pp_core.h"
}
void 
Cparallel_monitor_ph::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rparallel_monitor_phrase_:{
       Rparallel_monitor_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_monitor_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_monitor_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 7;
    

     sym->sr1();
     return;}
    case rhs1_Ropen_brace_:{
       Ropen_brace* sym;
     if(re->rule_ == 0){
       sym = new Ropen_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Ropen_brace_:{
       Ropen_brace* sym;
     if(re->rule_ == 0){
       sym = new Ropen_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rdirective_phrase_:{
       Rdirective_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     sym->sr1();
     return;}
    case rhs1_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs1_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Rparallel_directive_cweb_k_:{
       Rparallel_directive_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_directive_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_directive_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rparallel_directive_cweb_k_:{
       Rparallel_directive_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_directive_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_directive_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rparallel_directive_cweb_k_:{
       Rparallel_directive_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_directive_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_directive_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    default: return;
   }
}
